SystemOrganization addCategory: #MooseExecutionAnalyzer!
SystemOrganization addCategory: #'MooseExecutionAnalyzer-Tests'!
SystemOrganization addCategory: #'MooseExecutionAnalyzer-TestsScenarios'!

TestCase subclass: #ATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!ATest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:55'!
test
	A new foo! !

!ATest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
testBasic
	self assert: A new foo notNil! !

TestCase subclass: #MooseExecutionSimpleInvocationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-Tests'!

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/23/2012 15:08'!
createMooseModelFromPackage
	|packages task importer mooseModel|
"	
	importer:=MooseSqueakClassPackageImporterTask new.
	mooseModel := MooseModel new.
	importer
		importingContext: self createImportingContext;
		model: mooseModel;
		addFromPackagesNamed: #('MooseExecutionAnalyzer-TestsScenarios');
		candidateClass: self candidateListOperatorClass ;
		runWithProgress."
	packages := #('MooseExecutionAnalyzer-TestsScenarios').

       mooseModel := MooseModel new.
       task := MooseSqueakClassCategoryImporterTask new.
       task importerClass: SmalltalkImporter.
       task importingContext mergeClassAndMetaclass.
       task model: mooseModel.
       task runCandidateOperator.
       task addFromPackagesNamed: packages.
       task runWithProgress.
	^mooseModel.! !

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/23/2012 15:07'!
testDependenciesInHierarchy
	"This test checks that if a method is invocked and it is overwritten in the children of a hierarchy, the dependencies should be computed with the children and its father"

	| mooseModel aFAMIXMethod |
	mooseModel:=self createMooseModelFromPackage.
	MooseExecutionProfiler refineModel: mooseModel.
	aFAMIXMethod:=(mooseModel allMethods) detect: [ :famixMethod | famixMethod name = #drawOn:
								and: [ famixMethod parentType name = #NiceGUI ] ].
	
	self assert: aFAMIXMethod outgoingInvocations size =2.
	self assert: (aFAMIXMethod outgoingInvocations at: 2) candidates size =0. "The new invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size =2. "The drawOn invocation"
	self assert: ((aFAMIXMethod outgoingInvocations at: 2) candidates at: 1) parentType name = #Button.
	self assert: ((aFAMIXMethod outgoingInvocations at: 2) candidates at: 1) parentType name = #Widget.! !

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/23/2012 15:08'!
testSimpleInvocation
"This test checks the simplest case in which a class 'A' calls a method 'zork' that it is implemented in two classes 'B' and 'C'. However, 'A' only calls the 'B' class method"
	| mooseModel aFAMIXMethod |
	mooseModel:=self createMooseModelFromPackage.
	MooseExecutionProfiler refineModel: mooseModel.
	aFAMIXMethod:=mooseModel allMethods 
		detect: [ :famixMethod | famixMethod name = #foo
								and: [ famixMethod parentType name = #A ] ].
	self assert: aFAMIXMethod outgoingInvocations size =2.
	self assert: (aFAMIXMethod outgoingInvocations at: 2) candidates size =1. "The foo invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size =0. "The new invocation"
	self assert: ((aFAMIXMethod outgoingInvocations at: 2) candidates at: 1) parentType name = #B.! !

TestCase subclass: #NiceGUITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!NiceGUITest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:43'!
testDrawing
| gui canvas |
	gui := NiceGUI new.
	canvas := Canvas new.
	gui drawOn: canvas.
	self assert: gui notNil.! !

!MooseModel methodsFor: '*mooseexecutionanalyzer' stamp: 'SantiagoVidal 1/21/2012 14:38'!
runTests
	<menuItem: 'Refine model by running tests' category: 'Utilities'>
	MooseExecutionProfiler refineModel: self.
! !

MethodSpy subclass: #MooseExecutionMethod
	instanceVariableNames: 'calledMethods isCovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionMethod methodsFor: 'hooks' stamp: 'AlexandreBergel 1/18/2012 11:33'!
beforeRun: methodName with: listOfArguments in: receiver
	| c |
	isCovered := true.
	c := self callingMethod.
	c isSpy ifTrue: [ 
		c methodSpy calledMethods add: self ] ! !

!MooseExecutionMethod methodsFor: 'accessing' stamp: 'AlexandreBergel 5/6/2011 07:21'!
calledMethods
	^ calledMethods! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 13:23'!
getFamixMethodIn: aMooseModel
	"Return the famix methods contained in the model that corresponds to myself (i.e., same selector and same class name)"
	^ aMooseModel allMethods 
		detect: [ :famixMethod | famixMethod name = self selector
								and: [ famixMethod parentType name == self classSpy className ] ]
		ifNone: [ nil ]! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:25'!
hasAnyCallerFor: famixMethod
	"Return true if a method corresponding to the method has been profiled"

	^ calledMethods anySatisfy: [ :spyMethod |
			(spyMethod selector == famixMethod name) 
				and: [ spyMethod classSpy className = famixMethod parentType name ]
			]! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:30'!
hasCalledMethod
	^ self calledMethods notEmpty! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 15:09'!
hasCallerFor: famixMethod
	"Return true if a method corresponding to the method has been profiled"

	^ calledMethods anySatisfy: [ :spyMethod |
			(spyMethod selector == famixMethod name) 
				and: [ spyMethod classSpy className = famixMethod parentType name ]
			]! !

!MooseExecutionMethod methodsFor: 'initialize-release' stamp: 'SantiagoVidal 1/20/2012 15:52'!
initialize 
	super initialize.
	calledMethods := BoundedIdentitySet maxSize: 100.
	isCovered := false.
	! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:34'!
isCovered
	^ isCovered! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:43'!
matchingCandidatesFor: famixInvocation
	"Return the list of candidates of the invocation that correspond to a called method"
	
	| matchingCandidates |
	matchingCandidates := OrderedCollection new.
	famixInvocation candidates do: [ :famixMethod | 
		(self hasAnyCallerFor: famixMethod) ifTrue: [ matchingCandidates add: famixMethod ]
	].
	^ matchingCandidates! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/21/2012 17:36'!
refineInvocation: famixInvocation
	"Refine the candidate of the invocation according to what has been captured during the profiling"
	
	"If no candidate, then we do nothing"
	famixInvocation candidates ifEmpty: [ ^ self ].
	
	"We check if at least the selector match"
	"If no, then we do nothing""This checks if the call was used in the test"
	(calledMethods anySatisfy: [ :spyM | spyM selector == famixInvocation candidates first name ]) ifFalse: [ ^ self ].
	
	"self haltIf: [ famixInvocation candidates size > 1 ]."
	famixInvocation candidates copy do: [ :famixMethod | 
		(self hasCallerFor: famixMethod) "Ensure that the method call is of the same class"
			ifFalse: [ famixInvocation candidates remove: famixMethod ].
	].

 ! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 15:17'!
refineMethod: famixMethod
	"We remove the invocations wrongly computed in famixMethod"
	famixMethod outgoingInvocations do: [ :famixInvocation | 
		self refineInvocation: famixInvocation
	]. 
! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 15:17'!
refineModel: aMooseModel
	| famixMethod |
	
	"Do nothing if I have not been covered (i.e., not executed during the unit tests execution)"
	self isCovered ifFalse: [ ^ self ].
	
	"We get the famix method that corresponds to myself"
	famixMethod := self getFamixMethodIn: aMooseModel.
	
	"We now remove all the invocation wrongly computed by the smalltalk importer"
	"We have to check there is a method that correspond to myself. If none, then we do nothing"
	famixMethod ifNotNil: [ self refineMethod: famixMethod.]! !

AbstractSpyTest subclass: #MooseExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-Tests'!

!MooseExecutionTest methodsFor: 'hooks' stamp: 'AlexandreBergel 5/6/2011 07:20'!
profilerClass
	^ MooseExecutionProfiler  ! !

!MooseExecutionTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/6/2011 07:41'!
testBasic
	| profiler |
	profiler := self runScenario.
	self assert: ((profiler >> #TGCarExampleTest>>#testBasic) calledMethods includesAllOf: 
					{profiler >> #TGCar>>#carName: .
					 profiler >> #TGCar>>#addWheel: .
					 profiler >> #TGCar>>#driver: .
					}).
	self assert: (profiler >> #TGCar >> #addWheel:) calledMethods isEmpty.
	self assert: (profiler >> #TGCar >> #hasDriver) calledMethods isEmpty.
	self assert: ((profiler >> #TGDriver >> #isMale) calledMethods isEmpty).
	self assert: ((profiler >> #TGMaleDriver >> #isMale) calledMethods isEmpty).
	self assert: ((profiler >> #TGCar >> #giveMeANewCarForDriver:) calledMethods
					 includes: (profiler >> #TGMaleDriver >> #isMale)).
! !

PackageSpy subclass: #MooseExecutionPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionPackage class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForClass
	 ^ MooseExecutionClass! !

ClassSpy subclass: #MooseExecutionClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionClass class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForMethod
	 ^ MooseExecutionMethod! !

Profiler subclass: #MooseExecutionProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionProfiler class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:23'!
fd! !

!MooseExecutionProfiler class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 14:06'!
refineModel: aMooseModel
	"Public method"

	| packages|
	packages := aMooseModel allPackages asArray collect: [:p | p name asString ].
	
	(self runTestsForPackages: packages) refineModel: aMooseModel.! !

!MooseExecutionProfiler class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForPackage
	 ^ MooseExecutionPackage! !

!MooseExecutionProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 1/21/2012 14:26'!
refineModel: aMooseModel
	"main public method. This method has to be run after the profiling has been realized"
	self allMethods do: [ :m| m refineModel: aMooseModel ]! !

!MooseExecutionProfiler methodsFor: 'visualization' stamp: 'AlexandreBergel 5/5/2011 21:50'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

Object subclass: #A
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!A methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:11'!
foo
	| object |
 	object := B new.
 	object zork! !

Object subclass: #B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!B methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
zork
	 ^ 1! !

Object subclass: #C
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!C methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
zork
 	^ 2! !

Object subclass: #NiceGUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!NiceGUI methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:39'!
drawOn: aCanvas
	Button new drawOn: aCanvas.! !

Object subclass: #Widget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

Widget subclass: #Button
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!Button methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:37'!
drawOn: aCanvas
	"Drawing a button"! !

!Widget methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:37'!
drawOn: aCanvas
	self subclassResponsibility.! !

Widget subclass: #Window
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!Window methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:38'!
drawOn: aCanvas
	"Drawing a window"! !
